using System;
using System.Text.Json.Serialization;
using JacobTechEncryption.Enums;
using Luski.net.Enums;
using Luski.net.Enums.Public;
using Luski.net.JsonTypes.BaseTypes;

namespace Luski.net.JsonTypes.Public;

public class Channel : IncomingHTTP
{
    [JsonInclude]
    [JsonPropertyName("id")]
    public long ID { get; set; }
    [JsonInclude]
    [JsonPropertyName("parent")]
    public long Parent { get; set; }
    [JsonInclude]
    [JsonPropertyName("color")]
    public string Color { get; set; }
    [JsonInclude]
    [JsonPropertyName("type")]
    public ChannelType Type { get; set; }
    [JsonInclude]
    [JsonPropertyName("epoch")]
    public DateTime Epoch { get; set; }
    [JsonInclude]
    [JsonPropertyName("name")]
    public string Name { get; set; }
    [JsonInclude]
    [JsonPropertyName("description")]
    public string Description { get; set; }
    [JsonInclude]
    [JsonPropertyName("role_overides")]
    public long[] RoleOverides { get; set; }
    [JsonInclude]
    [JsonPropertyName("member_overides")]
    public long[] UserOverides { get; set; }
    [JsonInclude]
    [JsonPropertyName("title_encryption_key")]
    public long TitleEncryptionKey { get; set; }
    [JsonInclude]
    [JsonPropertyName("description_encryption_key")]
    public long DescriptionEncryptionKey { get; set; }
    [JsonInclude]
    [JsonPropertyName("encryption_keys")]
    public long[] EncryptionKeys { get; set; }
    [JsonInclude]
    [JsonPropertyName("title_encoder_type")]
    public EncoderType TitleEncoderType { get; set; }
    [JsonInclude]
    [JsonPropertyName("description_encoder_type")]
    public EncoderType DescriptionEncoderType { get; set; }
    [JsonInclude]
    [JsonPropertyName("encoder_types")]
    public EncoderType[] EncoderTypes { get; set; }
    [JsonInclude]
    [JsonPropertyName("picture_type")]
    public PictureType PictureType { get; set; }
}

[JsonSerializable(typeof(Channel))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.Unspecified,
    WriteIndented = false,
    DefaultIgnoreCondition = JsonIgnoreCondition.Never)]
internal partial class PublicChannelContext : JsonSerializerContext
{

}