using System.Text.Json.Serialization;
using Luski.net.JsonTypes.BaseTypes;

namespace Luski.net.JsonTypes.Public;

public class PublicSocketBulkMessage : IncomingHTTP
{
    [JsonInclude]
    [JsonPropertyName("messages")]
    public PublicMessage[]? Messages { get; set; } = default!;
}

[JsonSerializable(typeof(PublicSocketBulkMessage))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false,
    DefaultIgnoreCondition = JsonIgnoreCondition.Never)]
internal partial class PublicSocketBulkMessageContext : JsonSerializerContext
{

}