using System.Text.Json.Serialization;
using Luski.net.Enums.Public;
using Luski.net.JsonTypes.BaseTypes;

namespace Luski.net.JsonTypes.Public;

public class Role : IncomingHTTP
{
    public long id { get; set; }
    public string name { get; set; }
    public string display_name { get; set; }
    public int index { get; set; }
    public string color { get; set; }
    public string description { get; set; }
    public ServerPermission[] server_permissions { get; set; }
    public long[] members_list { get; set; }
}

[JsonSerializable(typeof(Role))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.Unspecified,
    WriteIndented = false,
    DefaultIgnoreCondition = JsonIgnoreCondition.Never)]
internal partial class RoleContext : JsonSerializerContext
{

}