using System.Text.Json.Serialization;

namespace Luski.net.JsonTypes;

public class ServerData
{
    [JsonInclude]
    [JsonPropertyName("address")]
    public string DomainAndPort = default!;
    [JsonInclude]
    [JsonPropertyName("secure")]
    public bool Secure;
}

[JsonSerializable(typeof(ServerData))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false)]
internal partial class ServerDataContext : JsonSerializerContext
{

}