using System.Text.Json.Serialization;
using Luski.net.JsonTypes.BaseTypes;

namespace Luski.net.JsonTypes;

public class ServerInfo : IncomingHTTP
{
    public string name { get; set; }
    public string wssv4 { get; set; }
    public string description { get; set; }
    public long owner { get; set; }
    
    [JsonInclude]
    [JsonPropertyName("alternate_servers")]
    public ServerData[] AlternateServers { get; set; } = default!;
}

[JsonSerializable(typeof(ServerInfo))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false)]
internal partial class ServerInfoContext : JsonSerializerContext
{

}